<?php
class crud
{
    // private database object\
    private $db;

    //constructor to initialize private variable to the database connection
    function __construct($conn)
    {
        $this->db = $conn;
    }

    public function getProvincias()
    {
        $provincias = ["A Coruña", "Alaba", "Albacete", "Alacant", "Almeria", "Asturies", "Ávila", "Badajoz", "Balears", "Barcelona", "Bizkaia", "Burgos", "Cáceres", "Cádiz", "Cantabria", "Castelló", "Ciudad Real", "Córdoba", "Cuenca", "Girona", "Granada", "Guadalajara", "Gipuzkoa", "Huelva", "Huesca", "Jaén", "La Rioja", "Las Palmas", "León", "Lleida", "Lugo", "Madrid", "Málaga", "Murcia", "Nafarroa", "Ourense", "Palencia", "Pontevedra", "Salamanca", "Santa Cruz de Tenerife", "Segovia", "Sevilla", "Soria", "Tarragona", "Teruel", "Toledo", "València", "Valladolid", "Zamora", "Zaragoza"];
        return $provincias;
    }

    public function getClasificacio()
    {
        return ["Preparación e hilado de fibras", "Fabricación de tejidos", "Fabricación de no tejidos", "Fabricación de textil-productos sanitarios", "Fabricación de textiles técnicos", "Acabado de textiles", "Fabricación de tejidos de punto", "Fabricación de artículos confeccionados con textiles", "Fabricación de alfombras", "Fabricación de cordelería", "Confección de prendas de vestir", "Fabricación de otros productos textiles"];
    }

    public function getIdCat($cat)
    {
        switch ($cat) {
            case "Preparacion e hilado de fibras":
                return 1;
            case "Fabricacion de tejidos":
                return 2;
            case "Fabricacion de no tejidos":
                return 3;
            case "Fabricacion de textil-productos sanitarios":
                return 4;
            case "Fabricacion de textiles tecnicos":
                return 5;
            case "Acabado de textiles":
                return 6;
            case "Fabricacion de tejidos de punto":
                return 7;
            case "Fabricacion de artículos confeccionados con textiles":
                return 8;
            case "Fabricacion de alfombras":
                return 9;
            case "Fabricacion de cordeleria":
                return 10;
            case "Confeccion de prendas de vestir":
                return 11;
            case "Fabricacion de otros productos textiles":
                return 12;
        }
        return 13;
    }

    public function getCatById($cat)
    {
        switch ($cat) {
            case 1:
                return "Preparación e hilado de fibras";
            case 2:
                return "Fabricación de tejidos";
            case 3:
                return "Fabricación de no tejidos";
            case 4:
                return "Fabricación de textil-productos sanitarios";
            case 5:
                return "Fabricación de textiles técnicos";
            case 6:
                return "Acabado de textiles";
            case 7:
                return "Fabricación de tejidos de punto";
            case 8:
                return "Fabricación de artículos confeccionados con textiles";
            case 9:
                return "Fabricación de alfombras";
            case 10:
                return "Fabricación de cordelería";
            case 11:
                return "Confección de prendas de vestir";
            case 12:
                "Fabricación de otros productos textiles";
        }
        return "Categoría";
    }

    public function getFiltre($categoria)
    {
        switch ($categoria) {
            case "Preparación e hilado de fibras":
                return "filter-fil";
            case "Fabricación de tejidos":
            case "Fabricación de no tejidos":
            case "Fabricación de textil-productos sanitarios":
            case "Fabricación de textiles técnicos":
            case "Fabricación de tejidos de punto":
                return "filter-teixit";
            case "Confección de prendas de vestir":
                return "filter-vestir";
            default:
                return "filter-altres";
        }
    }

    public function getFiltreText($categoria)
    {
        switch ($categoria) {
            case "Preparación e hilado de fibras":
                return "Hilatura";
            case "Fabricación de tejidos":
            case "Fabricación de no tejidos":
            case "Fabricación de textil-productos sanitarios":
            case "Fabricación de textiles técnicos":
            case "Fabricación de tejidos de punto":
                return "Tejido";
            case "Confección de prendas de vestir":
                return "Ropa";
            default:
                return "Otros";
        }
    }

    public function getProductsbyId($id)
    {
        if ($id != 1) {
            try {
                $sql = "SELECT * FROM `product` where user_id = :id";
                $stmt = $this->db->prepare($sql);
                $stmt->bindparam(':id', $id);
                $stmt->execute();
                #$result = $stmt->fetch();
                return $stmt;
            } catch (PDOException $e) {
                echo $e->getMessage();
                return false;
            }
        } else {
            try {
                $sql = "SELECT * FROM `product`";
                $stmt = $this->db->prepare($sql);
                $stmt->bindparam(':id', $id);
                $stmt->execute();
                #$result = $stmt->fetch();
                return $stmt;
            } catch (PDOException $e) {
                echo $e->getMessage();
                return false;
            }
        }
    }

    public function getOferentes($cat)
    {
        try {
            $sql = "SELECT  raoSocial,marca,url,descripcion,logo FROM `product` INNER JOIN `userdata`WHERE product.user_id = userdata.user_id AND product.categoria =:cat";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':cat', $cat);
            $stmt->execute();
            return $stmt;
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            echo $e->getMessage();
            return false;
        }
    }

    public function getOferta($marca, $categoria)
    {

        try {
            $sql = "SELECT * FROM `product` INNER JOIN `userdata` ON userdata.user_id = product.user_id WHERE categoria = :cat AND marca = :marca";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':cat', $categoria);
            $stmt->bindparam(':marca', $marca);
            $stmt->execute();
            $result = $stmt->fetch();
            return $result;
        } catch (PDOException $e) {
            echo $e->getMessage();
            return false;
        }
    }

    public function getInfo($idproduct, $cat)
    {
        try {
            $sql = "SELECT * FROM `" . $cat . "` INNER JOIN `product` ON " . $cat . ".id_product=product.idproduct WHERE id_product = :idproduct";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':idproduct', $idproduct);
            $stmt->execute();
            $result = $stmt->fetch();
            return $result;
        } catch (PDOException $e) {
            echo $e->getMessage();
            return false;
        }
    }


    public function getEstructura($catId)
    {
        try {
            $sql = "SELECT * FROM `categoria` WHERE id_categoria = :cat";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':cat', $catId);
            $stmt->execute();
            $result = $stmt->fetch();
            return $result['estructura'];
        } catch (PDOException $e) {
            echo $e->getMessage();
            return false;
        }
    }

    public function getCamps($cat)
    {
        $noaccents = array("a", "e", "i", "o", "u");
        $accents = array("á", "é", "í", "ó", "ú");
        $cat_neta = str_replace(" ", "_", str_replace($accents, $noaccents, lcfirst($cat)));
        try {
            $sql = "SELECT COLUMN_NAME,COLUMN_TYPE
            FROM INFORMATION_SCHEMA.COLUMNS
            WHERE TABLE_NAME LIKE 'product' OR TABLE_NAME LIKE :cat_neta;";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':cat_neta', $cat_neta);
            $stmt->execute();
            #$result = $stmt->fetch();
            return $stmt;
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }
        return $cat_neta;
    }

    private function getIdbyUsername($username){
        try{
            $sql = "select id from user where username = :username";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':username',$username);
            
            $stmt->execute();
            $result = $stmt->fetch();
            return $result['id'];
        }catch (PDOException $e) {
                echo $e->getMessage();
                return false;
        }
    }
    

    public function insertFilat($data, $file)
    {
        $tipos = "";
        $pigmentado = null;
        $nombre = null;
        $descripcion = null;
        $categoria = null;
        foreach ($data as $key => $value) {
            if (strpos($key, "tipo") > -1) {
                $tipos .= str_replace("tipos:", "", $value) . ",";
            } elseif ($key == "pigmentado") {
                $pigmentado = $value;
            } elseif ($key == "nombre") {
                $nombre = $value;
            } elseif ($key == "descripcion") {
                $descripcion = $value;
            } elseif ($key == "cat") {
                $categoria =  1;
            }
        }
        $tipos = rtrim($tipos, ",");
        
        $id = $_SESSION['userid'];
        if($id == 1){
            $id = $this->getIdbyUsername($data['username']);
        }
        //Insertar producte
        try {
            $sql = "INSERT INTO `product` (`user_id`, `idproduct`, `categoria`, `nombre`, `descripcion`) VALUES (:id, NULL,:cat,:nom,:descr)";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':id', $id);
            $stmt->bindparam(':cat', $categoria);
            $stmt->bindparam(':nom', $nombre);
            $stmt->bindparam(':descr', $descripcion);
            $stmt->execute();
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }
        //Traure l'ID del producte
        $idAssignat = "";
        try {
            $sql = "SELECT * FROM `product` WHERE user_id = :id AND categoria LIKE :cat";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':id', $id);
            $stmt->bindparam(':cat', $categoria);
            $stmt->execute();
            $idAssignat = $stmt->fetch()['idproduct'];
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }


        //PART DE LA IMATGE
        /* La part de la imatge */
        $orig_file = $file["imagen"]["tmp_name"];
        $target_dir = 'uploads/product/';
        $path_parts = pathinfo($file["imagen"]["name"]);
        if (isset($path_parts['extension'])) {

            $ext = $path_parts['extension'];
            $destination = $target_dir . $idAssignat . "." . $ext;
            move_uploaded_file($orig_file, $destination);
        } else {
            $destination = "uploads\product\default\blank.png";
        }


        //Afegir dades particulars
        try {
            $sql = "INSERT INTO `preparacion_e_hilado_de_fibras`(`id_product`, `tipo`, `pigmentado`, `imagen`) VALUES (:idAssignat,(:tipos),:pigmentado,:imagen)";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':idAssignat', $idAssignat);
            $stmt->bindparam(':tipos', $tipos);
            $stmt->bindparam(':pigmentado', $pigmentado);
            $stmt->bindparam(':imagen', $destination);
            $stmt->execute();
            return true;
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }
    }

    public function editNoticia($data,$file){
        $titular = $data['titular'];
        $subtitular = $data['subtitular'];
        $id = $data['id'];
        $cos = $data['cos'];

        //UPDATE GENERAL
        try {
            $sql = "UPDATE `noticia` SET `titular`=:titular,`subtitular`=:subtitular,`cos`=:cos WHERE idnoticia=:id";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':id', $id);
            $stmt->bindparam(':titular', $titular);
            $stmt->bindparam(':subtitular', $subtitular);
            $stmt->bindparam(':cos', $cos);
            $stmt->execute();
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }
        
        //PART DE LA IMATGE
        //Pujar i classificar la imatge
        $orig_file = $file["imagen"]["tmp_name"];
        $target_dir = 'uploads/new/';
        $path_parts = pathinfo($file["imagen"]["name"]);
        if (isset($path_parts['extension'])) {

            $ext = $path_parts['extension'];
            $destination = $target_dir . $id . "." . $ext;
            move_uploaded_file($orig_file, $destination);


            //Update de la imatge en la bbdd
            try {
                $sql = "UPDATE `noticia` SET `imagen`= :imagen WHERE idnoticia=:idnoticia";
                $stmt = $this->db->prepare($sql);
                $stmt->bindparam(':idnoticia', $id);
                $stmt->bindparam(':imagen', $destination);
                $stmt->execute();
            } catch (PDOException $e) {
                throw new PDOException($e->getMessage());
                return false;
            }
        }
        return true;
    }

    public function editFilat($data, $file)
    {

        $tipos = "";
        $pigmentado = null;
        $nombre = null;
        $descripción = null;
        $categoria = null;
        $idproduct = null;
        foreach ($data as $key => $value) {
            if (strpos($key, "tipo") > -1) {
                $tipos .= str_replace("tipos:", "", $value) . ",";
            } elseif ($key == "pigmentado") {
                $pigmentado = $value;
            } elseif ($key == "nombre") {
                $nombre = $value;
            } elseif ($key == "descripcion") {
                $descripcion = $value;
            } elseif ($key == "cat") {
                $categoria = $this->getIdCat($value);
            } elseif ($key == "idproduct") {
                $idproduct = $value;
            }
        }
        $tipos = rtrim($tipos, ",");

        //UPDATE DE LA CATEGORIA
        try {
            $sql = "UPDATE `preparacion_e_hilado_de_fibras` SET `tipo`=:tipo,`pigmentado`=:pigmentado WHERE id_product=:idproduct";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':idproduct', $idproduct);
            $stmt->bindparam(':tipo', $tipos);
            $stmt->bindparam(':pigmentado', $pigmentado);
            $stmt->execute();
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }

        //UPDATE GENERAL
        try {
            $sql = "UPDATE `product` SET `nombre`=:nombre,`descripcion`=:descr WHERE idproduct=:idproduct";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':idproduct', $idproduct);
            $stmt->bindparam(':nombre', $nombre);
            $stmt->bindparam(':descr', $descripcion);
            $stmt->execute();
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }

        //PART DE LA IMATGE
        //Pujar i classificar la imatge
        $orig_file = $_FILES["imagen"]["tmp_name"];
        $target_dir = 'uploads/product/';
        $path_parts = pathinfo($_FILES["imagen"]["name"]);
        if (isset($path_parts['extension'])) {

            $ext = $path_parts['extension'];
            $destination = $target_dir . $idproduct . "." . $ext;
            move_uploaded_file($orig_file, $destination);


            //Update de la imatge en la bbdd
            try {
                $sql = "UPDATE `preparacion_e_hilado_de_fibras` SET `imagen`= :imagen WHERE id_product=:idproduct";
                $stmt = $this->db->prepare($sql);
                $stmt->bindparam(':idproduct', $idproduct);
                $stmt->bindparam(':imagen', $destination);
                $stmt->execute();
            } catch (PDOException $e) {
                throw new PDOException($e->getMessage());
                return false;
            }
        }
        return true;
    }

    public function deleteProduct($idproduct)
    {
        $target_dir = 'uploads/product/';
        $files = scandir($target_dir);
        foreach ($files as $file) {
            if (strpos($file, $idproduct) > -1) {
                unlink($target_dir . $file);
            }
        }
        //borre el registre
        try {
            $sql = "DELETE FROM `product` WHERE `idproduct`=:idproduct";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':idproduct', $idproduct);
            $stmt->execute();
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }

        return true;
    }

    public function insertNoticia($post, $file)
    {
        $titular = $post['titular'];
        $subtitular = $post['subtitular'];
        $cos = $post['cos'];

        //Insertar producte
        try {
            $sql = "INSERT INTO `noticia` (`titular`, `subtitular`, `cos`,`dataPub`) VALUES (:titular,:subtitular,:cos,CURRENT_TIMESTAMP())";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':titular', $titular);
            $stmt->bindparam(':subtitular', $subtitular);
            $stmt->bindparam(':cos', $cos);
            $stmt->execute();
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }
        //Traure l'ID del producte
        $idAssignat = "";
        try {
            $sql = "SELECT * FROM `noticia` WHERE titular LIKE :titular";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':titular', $titular);
            $stmt->execute();
            $idAssignat = $stmt->fetch()['idnoticia'];
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }


        //PART DE LA IMATGE
        /* La part de la imatge */
        $orig_file = $file["imagen"]["tmp_name"];
        $target_dir = 'uploads/new/';
        $path_parts = pathinfo($file["imagen"]["name"]);
        if (isset($path_parts['extension'])) {

            $ext = $path_parts['extension'];
            $destination = $target_dir . $idAssignat . "." . $ext;
            move_uploaded_file($orig_file, $destination);
        } else {
            $destination = "uploads\\new\default\default.jpg";
        }


        //Afegir dades particulars
        try {
            $sql = "UPDATE `noticia` SET `imagen` = :imagen WHERE `noticia`.`idnoticia` = ".$idAssignat;
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':imagen', $destination);
            $stmt->execute();
            return true;
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }
    }

    public function getNoticies($pagina)
    {

        $limitInf = $pagina * 10;
        $limitSup = ($pagina + 1) * 10;

        try {
            $sql = "SELECT idnoticia,titular,subtitular,lastMod,dataPub,imagen FROM `noticia` LIMIT " . $limitInf . ", " . $limitSup;
            $stmt = $this->db->prepare($sql);
            //$stmt->bindparam(':limitInf', $limitInf);
            //$stmt->bindparam(':limitSup', $limitSup);
            $stmt->execute();
            #$result = $stmt->fetch();
            return $stmt;
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }
    }

    public function getNoticiesLlista()
    {

        try {
            $sql = "SELECT idnoticia,titular,subtitular,lastMod,dataPub FROM `noticia`";
            $stmt = $this->db->prepare($sql);
            $stmt->execute();
            #$result = $stmt->fetch();
            return $stmt;
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }
    }


    public function textNoticia($idNoticia)
    {
        try {
            $sql = "SELECT titular,`cos`,subtitular,lastMod,dataPub,imagen FROM `noticia` WHERE idnoticia LIKE :idNoticia";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':idNoticia', intval($idNoticia));
            $stmt->execute();
            $result = $stmt->fetch();
            return $result;
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }
    }

    public function deleteNoticia($idnoticia)
    {
        $target_dir = 'uploads/new/';
        $files = scandir($target_dir);
        foreach ($files as $file) {
            if (strpos($file, $idnoticia) > -1) {
                unlink($target_dir . $file);
            }
        }
        //borre el registre
        try {
            $sql = "DELETE FROM `noticia` WHERE `idnoticia`=".$idnoticia;
            $stmt = $this->db->prepare($sql);
            
            $stmt->execute();
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }

        return true;
    }


    public function formatDate($date)
    {
        setlocale(LC_ALL, "es_ES", 'Spanish_Spain', 'Spanish');
        $any = substr($date, 0, 10);
        $days = ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Satuday", "Sunday"];
        $dies = ["Lunes", "Martes", "Miércoles", "Jueves", "Viernes", "Sábado", "Domingo"];
        $months = ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'];
        $meses = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
        return str_replace($days, $dies, date("l", strtotime("$any"))) . ", " . date("d", strtotime("$any")) . " de " . str_replace($months, $meses, date("m", strtotime("$any")));
    }

    public function formatTime($date)
    {
        $hora = substr($date, 11, 16);
        return $hora;
    }

    public function paginationNumber()
    {
        try {
            $sql = "SELECT COUNT(*) FROM `noticia`";
            $stmt = $this->db->prepare($sql);
            $stmt->execute();
            $result = $stmt->fetch();
            return intval($result['COUNT(*)'] / 10) + 1;
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }
    }

    public function getEmail($userId)
    {
        try {
            $sql = "SELECT username FROM `user` WHERE id LIKE 3";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':userID', intval($userId));
            $stmt->execute();
            $result = $stmt->fetch();
            return $result['username'];
        } catch (PDOException $e) {
            throw new PDOException($e->getMessage());
            return false;
        }
    }
}
