<?php 

    class user{
        // private database object\
        private $db;
        
        //constructor to initialize private variable to the database connection
        function __construct($conn){
            $this->db = $conn;
        }

        public function insertUser($username,$password,$nomCognoms,$raoSocial,$marca,$url,$cif,$pais,$provincia,$destination){
            try {
                $result = $this->getUserbyUsername($username);
                if($result['num'] > 0){
                    return false;
                } else{
                    $new_password = md5($password.$username);
                    // define sql statement to be executed
                    $sql = "INSERT INTO user (username,password) VALUES (:username,:password)";
                    //prepare the sql statement for execution
                    $stmt = $this->db->prepare($sql);
                    // bind all placeholders to the actual values
                    $stmt->bindparam(':username',$username);
                    $stmt->bindparam(':password',$new_password);
                    
                    // execute statement
                    $stmt->execute();
                    //extra info
                    $id = $this->getUserId($username,$new_password);
                    $this->insertDataUser($id['id'],$nomCognoms,$raoSocial,$marca,$url,$username,$cif,$pais,$provincia,$destination);
                    return true;
                }
                
        
            } catch (PDOException $e) {
                echo $e->getMessage();
                return false;
            }
        }

        public function getUserId($username,$password){
            try{
                $sql = "select * from user where username = :username AND password = :password";
                $stmt = $this->db->prepare($sql);
                $stmt->bindparam(':username', $username);
                $stmt->bindparam(':password', $password);
                $stmt->execute();
                $result = $stmt->fetch();
                return $result;
           }catch (PDOException $e) {
                echo $e->getMessage();
                return false;
            }
        }

        public function getUser($username,$password){
            try{
                $sql = "select * from user INNER JOIN userdata ON user.id=userdata.user_id where username = :username AND password = :password";
                $stmt = $this->db->prepare($sql);
                $stmt->bindparam(':username', $username);
                $stmt->bindparam(':password', $password);
                $stmt->execute();
                $result = $stmt->fetch();
                return $result;
           }catch (PDOException $e) {
                echo $e->getMessage();
                return false;
            }
        }

        public function getUserbyUsername($username){
            try{
                $sql = "select count(*) as num from user where username = :username";
                $stmt = $this->db->prepare($sql);
                $stmt->bindparam(':username',$username);
                
                $stmt->execute();
                $result = $stmt->fetch();
                return $result;
            }catch (PDOException $e) {
                    echo $e->getMessage();
                    return false;
            }
        }

        public function getUserbyId($id){
            try{
                $sql = "select username from user where id = :id";
                $stmt = $this->db->prepare($sql);
                $stmt->bindparam(':id',$id);
                
                $stmt->execute();
                $result = $stmt->fetch();
                return $result;
            }catch (PDOException $e) {
                    echo $e->getMessage();
                    return false;
            }
        }


        public function getUsers(){
            try{
                $sql = "SELECT id,username FROM user";
                $result = $this->db->query($sql);
                return $result;
            }catch(PDOException $e){
                echo $e->getMessage();
                return false;
            }
        }

        public function insertDataUser($id,$nomCognoms,$raoSocial,$marca,$url,$email,$cif,$pais,$provincia,$destination){            
            $sql = "INSERT INTO userdata (user_id,nomCognoms,raoSocial,marca,url,email,cif,pais,provincia,logo) VALUES (:id,:nomCognoms,:raoSocial,:marca,:url,:email,:cif,:pais,:provincia,:logo)";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':id', $id);
            $stmt->bindparam(':nomCognoms', $nomCognoms);
            $stmt->bindparam(':raoSocial', $raoSocial);
            $stmt->bindparam(':marca', $marca);
            $stmt->bindparam(':url', $url);
            $stmt->bindparam(':email', $email);
            $stmt->bindparam(':cif', $cif);
            $stmt->bindparam(':pais', $pais);
            $stmt->bindparam(':provincia', $provincia);
            $stmt->bindparam(':logo', $destination);
            try{
            
            $stmt->execute();
                return true;

            }catch(PDOException $e){
                throw new PDOException($e->getMessage()."Valores:".$sql);
                echo $e->getMessage();
                return false;
            }
        }

        public function editUser($id, $nomCognoms, $raoSocial, $marca, $url, $cif, $pais, $provincia){
            $sql = "UPDATE `userdata` SET `nomCognoms`=:nomCognoms,`raoSocial`=:raoSocial,`marca`=:marca,`url`=:url,`cif`=:cif,`pais`=:pais,`provincia`=:provincia WHERE user_id = :id";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':id', $id);
            $stmt->bindparam(':nomCognoms', $nomCognoms);
            $stmt->bindparam(':raoSocial', $raoSocial);
            $stmt->bindparam(':marca', $marca);
            $stmt->bindparam(':url', $url);
            $stmt->bindparam(':cif', $cif);
            $stmt->bindparam(':pais', $pais);
            $stmt->bindparam(':provincia', $provincia);
            try{
            
            $stmt->execute();
                return true;

            }catch(PDOException $e){
                throw new PDOException($e->getMessage()."Valores:".$sql);
                echo $e->getMessage();
                return false;
            }   

        }

        public function changeAvatar($newAvatar){
            $sql = "UPDATE `userdata` SET `logo`=:logo WHERE `user_id` = :id";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':logo', $newAvatar);
            $stmt->bindparam(':id', $_SESSION['userid']);
            try{
            
                $stmt->execute();
                    return true;
    
                }catch(PDOException $e){
                    throw new PDOException($e->getMessage());
                    echo $e->getMessage();
                    return false;
                }  
        }

        public function changeOtherAvatar($newAvatar,$id){
            $sql = "UPDATE `userdata` SET `logo`=:logo WHERE `user_id` = :id";
            $stmt = $this->db->prepare($sql);
            $stmt->bindparam(':logo', $newAvatar);
            $stmt->bindparam(':id', $id);
            try{
            
                $stmt->execute();
                    return true;
    
                }catch(PDOException $e){
                    throw new PDOException($e->getMessage());
                    echo $e->getMessage();
                    return false;
                }  
        }

        public function verticalOHoriztontal($foto){
            $size = getimagesize($foto);
            return $size['0']<=$size['1'] ? "img-to-fit": "img-to-stretch";
        }

        public function getUserData($id){
            try{
                $sql = "SELECT * FROM userdata WHERE user_id ='".$id."'";;
                $result = $this->db->query($sql);
                return $result;
            }catch(PDOException $e){
                echo $e->getMessage();
                return false;
            }


            
        }

  
    }
