<?php
$title = 'Cartera';
$prova = false;
include_once 'includes/session.php';
require_once 'db\conn.php';
require_once 'includes\auth_check.php';
if ($_SERVER['REQUEST_METHOD'] == 'POST') {
  echo $crud->deleteProduct($_POST['idproduct']);
  $prova = true;
}
require_once 'forms\header.php';
?>

<main id="main">

  <!-- ======= Breadcrumbs ======= -->
  <section id="breadcrumbs" class="breadcrumbs">
    <div class="container">

      <ol>
        <li><a href="index.php">Home</a></li>
        <li><a href="home-user.php"><?php echo $_SESSION['raoSocial'] ?> </span> <span class="sr-only">(current)</a></li>
        <li><?php echo $title ?> </span> <span class="sr-only">(current)</li>
      </ol>
      <h2>Cartera de productos</h2>
    </div>
  </section><!-- End Breadcrumbscommitplease-->


  <section class="inner-page">
    
  <?php if($prova)echo '<div class="alert alert-info text-center">Producto eliminado correctamente. </div>';?>
    <?php if(isset($_GET['added']))echo '<div class="alert alert-info text-center">Producto añadido correctamente. </div>';?>
    <?php if(isset($_GET['edited']))echo '<div class="alert alert-info text-center">Producto modificado correctamente. </div>';?>
    <div class="container ">
      <h4>Herramientas de cartera</h4>
      <hr>
      <a href="addproduct.php"><button class="btn btn-primary" style="background: #ed502e;border: 0;padding: 10px 30px;border-radius: 4px;color: #fff;transition: 0.4s;align-items:center;">Añadir productos</button></a>
      <br>
    </div>
    <br>
    <div class="container">
      <?php
      $products = $crud->getProductsbyId($_SESSION['userid']);
      if ($products->rowCount() != 0) { ?>
        <h4>Cartera actual</h4>
        <table class="table table-hover table-responsive">
          <thead>
            <tr>
              <th scope="col" width="5%">id de Producto</th>
              <?php if ($_SESSION['userid'] == 1) { ?><th scope="col" class="width: 20%">Usuario</th><?php } ?>
              <th scope="col" width="20%">Categoría</th>
              <th scope="col" width="20%">Nombre</th>
              <th scope="col" width="45%">Descripción</th>
              <th scope="col" width="12%">Acciones</th>
            </tr>
          </thead>
          <tbody>
            <?php
            $i = 0;
            while ($row = $products->fetch(PDO::FETCH_ASSOC)) {
            ?>
              <tr data-aos="zoom-in" data-aos-delay="<?php echo $i ?>">
                <th scope="row"><?php echo $row['idproduct']; ?></th>
                <?php if ($_SESSION['userid'] == 1) { ?><th scope="row"><?php echo $user->getUserbyId($row['user_id'])['username']; ?></th><?php } ?>
                <td><?php echo $crud->getCatById($row['categoria']); ?></td>
                <td><?php echo $row['nombre']; ?></td>
                <td><?php echo substr($row['descripcion'], 0, 39);
                    if (strlen($row['descripcion']) > 39) echo "..."; ?></td>
                <td style="text-align:center;vertical-align:middle">
                  <a href="editproduct.php?product_id=<?php echo $row['idproduct']; ?>&cat=<?php echo $row['categoria'] ?>" class="btn btn-info col-12 mb-1">Editar</a>
                  <a class="btn btn-danger col-12" data-toggle="modal" data-target="#modalCenterid<?php echo $row['idproduct'] ?>"><i class="bx bx-trash"></i></a>
                </td>
                <div class="modal fade" id="modalCenterid<?php echo $row['idproduct'] ?>" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
                  <div class="modal-dialog modal-dialog-centered" role="document">
                    <div class="modal-content">
                      <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLongTitle">¿Está seguro de que quiere eliminar este producto?</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                          <span aria-hidden="true">&times;</span>
                        </button>
                      </div>
                      <div class="modal-body">
                        <strong>Nombre: </strong><?php echo $row['nombre'] . "\n"; ?>
                        <br>
                        <strong>Categoría: </strong><?php echo $crud->getCatById($row['categoria']); ?>
                        <br>
                        <strong>Descripción: </strong><?php echo substr($row['descripcion'], 0, 39);
                                                      if (strlen($row['descripcion']) > 39) echo "..."; ?>
                      </div>
                      <div class="modal-footer">
                        <form action="<?php echo htmlentities($_SERVER['PHP_SELF']); ?>" method="post">
                          <input type="hidden" name="idproduct" value="<?php echo $row['idproduct']; ?>" readonly>
                          <div class="input" name="idproduct" value="<?php echo $row['idproduct']; ?>"></div>
                          <button type="submit" class="btn btn-danger">Eliminar</button>
                        </form>
                        <button type="button" class="btn btn-success" data-dismiss="modal">Volver</button>

                      </div>
                    </div>
                  </div>
                </div>
              </tr>

          <?php
              $i += 150;
            }
          }
          ?>
          </tbody>
        </table>
    </div>

  </section>

</main><!-- End #main -->
<?php require_once 'forms\footer.php' ?>